#define MAX_ENEMIES (10)
#define MAX_BLOCKS (20)
#define PI (3.14159265358979)

typedef struct{
     int xen;
     int yen;
     float enrot;
     float enrotemp;
     int enspeed;
}enemy;

typedef struct{
	int stackx;
	int stacky;
	int num;
	bool enable;
}brick;


float ToDegrees(float radians){
     return radians*(180/PI);
}

float ToRadians(float degrees){
     return degrees*(PI/180);
}

void oslDrawPixel(float x,float y, OSL_COLOR color){
     int gx = (int)x;
     int gy = (int)y;
     oslDrawFillRect(gx,gy,gx+8,gy+8,color);
}


int collision(OSL_IMAGE *img1,float img1posX, float img1posY, OSL_IMAGE *img2, float img2posX, float img2posY ) {
   int collision;
   collision = 0;
   float img1width  = img1->stretchX;
   float img1height = img1->stretchY;
   float img2width  = img2->stretchX;
   float img2height = img2->stretchY;
    
   if ((img1posX + img1width > img2posX) &&
       (img1posX  < img2posX + img2width) &&
       (img1posY + img1height > img2posY) &&
       (img1posY < img2posY + img2height) ) {
         collision = 1;                
   }      
   return collision;
} 


void oslDrawThickCircle(float x, float y, float radius, OSL_COLOR color){
	int i = 1;
     while(i<360){
          float t1x = x + sinf(ToRadians(i))*radius;
          float t1y = y - cosf(ToRadians(i))*radius;
	  i += 18;
          float t2x = x + sinf(ToRadians(i))*radius;
          float t2y = y - cosf(ToRadians(i))*radius;
	  oslDrawLine((int)t1x,(int)t1y,(int)t2x,(int)t2y,color);


     }
}


int lineCollision(int lineX, OSL_IMAGE *img, float imgposX ) { 
   int collision;
   collision = 0;

   float imgwidth  = img->stretchX;

if	((lineX > imgposX) &&
	 (lineX < imgposX + imgwidth)){
	 collision = 1;}

	return collision;
}// only detects lines that are straight Y-wise

void fadeOut(){
int alpha = 1;
float lineY1 = 136;
float lineY2 = 136;

while(alpha != 0){
	oslStartDrawing();
	oslDrawFillRect(0,0,480,272,(RGBA(0,0,0,alpha)));

	oslDrawLine(0,(int)lineY1,480,(int)lineY1,(RGBA(0,0,255,255)));
	oslDrawLine(0,(int)lineY2,480,(int)lineY2,(RGBA(0,0,255,255)));

	oslEndDrawing();
	oslSyncFrame();

	lineY1 += 2.72;
	lineY2 -= 2.72;

	alpha++;
	if(alpha >= 50){alpha = 0;}
}
}

void fadeIn(int alpha, float lineY1, float lineY2){


if(alpha != 0){
	oslDrawFillRect(0,0,480,272,(RGBA(0,0,0,alpha)));
	oslDrawLine(0,(int)lineY1,480,(int)lineY1,(RGBA(0,0,255,255)));
	oslDrawLine(0,(int)lineY2,480,(int)lineY2,(RGBA(0,0,255,255)));
}
}

void fullscreenStatic(int alpha){
	int x = 0;
	int y = 0;
	int grayscale;
	while(y <=272){
		grayscale = rand() % 254 + 1;
		oslDrawPixel(x,y,(RGBA(grayscale,grayscale,grayscale,alpha)));
		if(x < 480){
			x += 8;
		}else { x = 0; y += 8;}
	}
}

void fadeInOutBoss(int alpha, float lineY1, float lineY2){
	oslDrawFillRect(0,0,480,272,(RGBA(0,0,0,alpha)));
	oslDrawLine(0,(int)lineY1,480,(int)lineY1,(RGBA(255,0,0,255)));
	oslDrawLine(0,(int)lineY2,480,(int)lineY2,(RGBA(255,0,0,255)));
}
int laserCollision(int lineX1, int lineY1, int lineX2, int lineY2, OSL_IMAGE *img,float imgposX, float imgposY){
   int collision;
   collision = 0;
   float imgwidth  = img->stretchX;
   float imgheight = img->stretchY + 10;
    
   if ((imgposX + imgwidth > lineX1) &&
       (imgposX  < lineX1 + (lineX1 - lineX2)) &&
       (imgposY + imgheight > lineY1) &&
       (imgposY < lineY1 + (lineY1 - lineY2)) ) {
         collision = 1;                
   }      
   return collision;
}



